/*
 *
 *
 *   rtwin.h
 *
 *   Copyright (C) 2003, by the Grand River Dam Authority,
 *   All rights reserved.
 *
 *   Author: Matt Roberts
 *
 *
 */


#ifndef __RISTERMWIN_H
#define __RISTERMWIN_H

#include <string>
#include <curses.h>

#include "winbase.h"


/*
 *
 *
 *    class RISFilter
 *
 *
 */

class RISTerminalWindow : public WinBase {
	private:
		WINDOW *win;
		short rf_alarm;
		short rf_normal;
		bool escape;
		bool cr;

	private:
		void init (void);

	public:
		RISTerminalWindow(short normal = -1, short alarm = -1);
		RISTerminalWindow(WINDOW *w, short normal = -1, short alarm = -1);
		~RISTerminalWindow(void) { /* noop */ };

		int write (const std::string &s) { return write((const unsigned char*)s.c_str(), s.size()); };
		int write (const unsigned char *buffer, size_t count);

		int put (int ch);

		void setAlarmCode  (short cp) { rf_alarm  = cp; };
		void setNormalCode (short cp) { rf_normal = cp; };

		void refresh (void) { wrefresh(win); };
		void test (void);

		RISTerminalWindow &operator = (WINDOW *w);
};


#endif /* __RISTERMWIN_H */
