/*
 *
 *
 *   sgwin.cc
 *
 *   Copyright (C) 2003, by the Grand River Dam Authority,
 *   All rights reserved.
 *
 *   Author: Matt Roberts
 *
 *
 */


#include <iostream>
#include <fstream>
#include <string>

#include <cctype>
#include <curses.h>

#include "sgwin.h"


// allow empty lines
const static bool empty = true;

// work in std:: namespace
using namespace std;


/*
 *
 *   SGTermWindow::write(...)
 *
 */

int SGTerminalWindow::write (const unsigned char *buffer, size_t count) {
	const unsigned char *cp = 0;

	if (count == 0)
		return 0;

	for (cp = buffer; cp != (buffer + count); ++cp) {
		switch (*cp) {
			//case '\r':
			case '\n':
				if (!cr)
					if (waddch(win, '\n') == ERR)
						return ERR;
				cr = true;
				break;

			default:
				if (isprint(*cp)) {
					if (waddch(win, (*cp)) == ERR)
						return ERR;
				}

				if (empty)
					cr = false;
				break;
		}
	}

	// output the result
	return OK;
}


int SGTerminalWindow::put (int ch) {
	int result = waddch(win, ch);
	if (result == OK)
		wrefresh(win);
	return result;
}

// EOF
