/*
 *
 *   sgwin.h
 *
 *   Copyright (C) 2003, by the Grand River Dam Authority,
 *   All rights reserved.
 *
 *   Author: Matt Roberts
 *
 */


#ifndef __SGTERMWIN_H
#define __SGTERMWIN_H

#include <string>
#include <curses.h>
#include "winbase.h"


/*
 *
 *
 *    class SGTerminalWindow
 *
 *
 */

class SGTerminalWindow : public WinBase {
	private:
		WINDOW *win;
		short rf_alarm;
		short rf_normal;
		bool escape;
		bool cr;

	public:
		SGTerminalWindow(short normal = -1, short alarm = -1);
		SGTerminalWindow(WINDOW *w, short normal = -1, short alarm = -1);
		~SGTerminalWindow(void) { /* noop */ };

		int write (const std::string &s) { return write((const unsigned char*)s.c_str(), s.size()); };
		int write (const unsigned char *buffer, size_t count);

		int put (int ch);

		void setAlarmCode  (short cp) { rf_alarm  = cp; };
		void setNormalCode (short cp) { rf_normal = cp; };

		void refresh (void) { wrefresh(win); };

		SGTerminalWindow &operator = (WINDOW *w) { if (w) win = w; return(*this);};
};


inline SGTerminalWindow::SGTerminalWindow(WINDOW *w, short normal, short alarm)
	: win(w), rf_alarm(alarm), rf_normal(normal), escape(false), cr(false) {
	/* noop */
}

inline SGTerminalWindow::SGTerminalWindow(short normal, short alarm)
	: win(NULL), rf_alarm(alarm), rf_normal(normal), escape(false), cr(false) {
	/* noop */
}

#endif /* __SGTERMWIN_H */
